#include <iostream>
#include <cstdlib>

using namespace std;


class Vaisseau
{
protected:
	int a;
public:
	Vaisseau() {cout << "Vaisseau::Vaisseau" << endl;}
	~Vaisseau(){cout << "Vaisseau::~Vaisseau" << endl;}
	void plouf(){cout << "Vaisseau::plouf" << endl;}
	void test_vaisseau()
	{
		a=1;
		cout << "Vaisseau::test_vaisseau" << endl;
	}
};

class LanceMissile:public Vaisseau
{
protected:
	int b;
public:
	LanceMissile(){cout << "LanceMissile::LanceMissile" << endl;}
	~LanceMissile(){cout << "LanceMissile::~LanceMissile" << endl;}
	void plouf(){cout << "LanceMissile::plouf" << endl;}
	void test_lancemissile()
	{
		a=2;
		b=3;
		cout << "LanceMissile::test_lancemissile" << endl;
	}
};

class MantaShip:public LanceMissile
{
protected:
	int c;
public:
	MantaShip(){cout << "MantaShip::MantaShip" << endl;}
	~MantaShip(){cout << "MantaShip::~MantaShip" << endl;}
	void plouf(){cout << "MantaShip::plouf" << endl;}
	void test_mantaship()
	{
		a=4;
		b=5;
		c=6;
		cout << "MantaShip::test_mantaship" << endl;
	}
	void testheritagesecurit()
	{
		test_lancemissile();
		test_vaisseau();
	}
};


void fonc()
{
	cout << "infonc" << endl;
	MantaShip m;
	m.plouf();
	m.test_mantaship();
	m.test_lancemissile();
	m.test_vaisseau();
	cout << "fin fonc" << endl;
}

void fonc2()
{
	cout << "infonc2" << endl;
	LanceMissile m;
	m.plouf();
	//m.Vaisseau::plouf();
	m.test_lancemissile();
	m.test_vaisseau();
	cout << "fin fonc2" << endl;
}

void fonc3()
{
	cout << "infonc3" << endl;
	Vaisseau m;
	//m.a = 5;
	m.plouf();
	m.test_vaisseau();
	cout << "fin fonc3" << endl;
}

int main()
{
	fonc();
	fonc2();
	fonc3();
	system("pause");
	return 0;
}

/*!F

  Notion d'hritage.
  Ce tuto est en 2 parties.

  D'abord, il montre l'hritage pour les dbutants, ensuite, quelques tests rigolos pour ceux qui veulent

Notion pour dtants :
*********************

  On va dire qu'un vaisseau, c'est un truc assez gnral.
  Un Lance Missile, c'est un vaisseau, mais avec des particularits en plus
  Un Manta, c'est un Lance Missile, mais avec des particularits en plus.

  On dfini une classe Vaisseau, avec  les particularits gnrales d'un vaisseau
  On met ses donnes "prives" en protected.

  C'est a dire, que si dans fonc3(), on fait m.a = 5 (voir ligne commente), alors on se fait arreter a la compilation
  En effet, a est protg, donc on ne peut pas la piloter de l'extrieur.

  LanceMissile hrite de Vaisseau.
  Il hrite aussi de ses donnes protges : donc, dans test_lancemissile, la ligne a=2 est tolre.

  test : 
  remplacez, dans vaisseau, protected par private.
  la ligne a=2 est maintenant interdite :

  - protected protege les donnes pour la classe, et ses hritieres.
  - private protege les donnes pour la classe UNIQUEMENT (donc pour vaisseau, pas "lancemissile")

  Pour dbutants : pour dclarer un hritage, utilisez public comme ceci :
  class LanceMissile:public Vaisseau


// fonctions dfinies dans meres et filles, comment choisir ?
-------------------------------------------------------------

  L'appel de "plouf" :

  Comme vous le voyez, la fonction plouf est dfinie dans chaque classe.
  Quand, dans une classe fille, vous redefinissez une fonction de la mere, alors c'est celle de la fille qui est appele.
  (vous le voyez en lanant le programme, les fonctions ont toute un cout, pour montrer ou on passe)

  Vous pouvez nanmoins toujours appeler explicitement la fonction plouf de la mere ainsi :
  m.Vaisseau::plouf();  (dcomentez la ligne dans fonc2)



Notions plus avances
*********************

  Tous les hritages prsents sont publiques

  Remplacer public par protected dans :
  
  class LanceMissile:public Vaisseau

  --> 	m.test_vaisseau(); dans fonc et fonc2 refusent de fonctionner.

  En effet, un hritage protected ne rcupere pas les mthodes publiques de la mere.
  Ainsi, vous ne pourrez vous servir de test_vaisseau() que dans une des mthodes de LanceMissile OU d'une de ses filles (Manta par exemple)

  Si maintenant vous mettez 
  class LanceMissile:private Vaisseau

  La, c'est pareil a une diffrence pres :
  Ainsi, vous ne pourrez vous servir de test_vaisseau() que dans une des mthodes de LanceMissile MAIS PAS d'une de ses filles (Manta par exemple)

  Si vous mettez private, d'autre messages d'erreur apparaissent :

  	void testheritagesecurit()
	{
		test_lancemissile();
		test_vaisseau();              <------- Ici, car on essaie, a partir de Manta, d'accder a la classe Vaisseau, et a n'est pas possible pour la raison vue au dessus.

	}

	void test_mantaship()
	{
		a=4;       <------- Ici, car, du a l'hritage priv, tout devient priv dans la classe mere pour cetet instance, y compris les champs protected qui deviennent privs.
		b=5;
		c=6;
		cout << "MantaShip::test_mantaship" << endl;
	}

Utilisation d'un hritage priv ou protg :
********************************************

  Quel est l'intret d'hriter d'une classe si ce n'est pas pour rendre publique ses mthodes ?

  Prenons un exemple :

  Vous avez une classe de liste chaine : cette classe permet, en public, d'ajouter des lments des 2 cots, et d'en enlever des 2 cots.

  Vous voulez faire une classe PILE a partir de la : c'est a dire une classe ou finalement, on empile et dpile des lments.
  Et bien, comme votre pile sera en interne, une liste chaine, vous faites hriter pile de list.
  Cependant, vous ne voulez pas qu'on puisse, dans une pile, insrer ou supprimer des lments ou on veut.
  Donc vous coupez l'acces aux mthodes publiques de la classe mere "liste".

  --> Hritage non publique.

!*/

/*!E
	No explanations yet.
!*/

/*
titre: Hritage.
titreE: Heritage.
meta: C++;heritage
metaE: C++;heritage
desc : Hritage de classes.
descE : Heritage.
cle  : 
*/

